/*
 * Copyright 2013 Yuichiro Moriguchi
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package net.morilib.sh;

import java.io.IOException;
import java.io.InputStream;
import java.io.PrintStream;

import net.morilib.sh.builtin.ShBuiltInCommands;
import net.morilib.sh.file.ShSubFileSystem;
import net.morilib.sh.misc.XtraceStream;

public class ShTreeSubprocess implements ShTree {

	private ShTree line;

	public ShTreeSubprocess(ShTree line) {
		this.line  = line;
	}

	public int eval(ShEnvironment env,
			ShFileSystem fs,
			ShBuiltInCommands cmds,
			ShRuntime run,
			InputStream in,
			PrintStream out,
			PrintStream err,
			XtraceStream p) throws IOException, ShSyntaxException {
		ShEnvironment e2;
		int r, n;

		try {
			e2 = new ShRootShellEnvironment(env.getEnvironment());
			r  = line.eval(e2, new ShSubFileSystem(fs), cmds, run, in,
					out, err, p);
			n  = Integer.parseInt(e2.find("$"));
			ShProcessNumber.releaseNumber(n);
			return r;
		} catch(ShExitException e) {
			return e.getCode();
		}
	}

	public void compileInternally(ShTreeExpressionMachine.Builder b,
			Object brk, Object cnt) {
		b.add(this);
	}

	public String toString() {
		return "(" + line.toString() + ")";
	}

}
